/*+
    ARES/HADES/BORG Package -- ./libLSS/data/lensing.hpp
    Copyright (C) 2020 Natalia Porqueres <n.porqueres@imperial.ac.uk>

    Additional contributions from:
       Guilhem Lavaux <guilhem.lavaux@iap.fr> (2021)

+*/
#ifndef __LIBLSS_LENSING_HPP
#  define __LIBLSS_LENSING_HPP

#  include <CosmoTool/hdf5_array.hpp>
#  include "libLSS/physics/projector_lensing.hpp"

namespace LibLSS {

  struct BaseLosDescriptor {
    unsigned long long id;
    long phi, theta;
    double shearR, shearI;
    long tomobin;
  };

}; // namespace LibLSS

/* HDF5 complex type */
CTOOL_STRUCT_TYPE(
    LibLSS::BaseLosDescriptor, HDF5T_BaseLosDescriptor,
    ((unsigned long long, id))((long, phi))((long, theta))((double, shearR))(
        (double, shearI))((long, tomobin))

);

#endif
// ARES TAG: authors_num = 1
// ARES TAG: name(0) = Natalia Porqueres
// ARES TAG: email(0) = n.porqueres@imperial.ac.uk
// ARES TAG: year(0) = 2020
