#pragma once
#include "libLSS/physics/data/data_representation.hpp"
#include <vector>
#include <typeindex>

namespace LibLSS {

  namespace DataRepresentation {

    class ChainRepresentation : public AbstractRepresentation {
    private:
      AbstractRepresentation_p base_representation;
      BackwardConverter closing_converter;

    public:
      // This is a dummy representation to encode the chaining of descriptors.
      ChainRepresentation(
          std::unique_ptr<AbstractRepresentation> &&base_ptr =
              std::unique_ptr<AbstractRepresentation>(),
          BackwardConverter cvt = BackwardConverter());

      unsigned int dimensions() override;

      std::type_index getType() const override;
      AbstractRepresentation_p shallowMove() override;
      AbstractRepresentation_p close() override;

      void setTopRepresentation(AbstractRepresentation_p top);
      AbstractRepresentation *getTop();

      static Descriptor
      makeChainedDescriptors(std::vector<Descriptor> desc_chain);
    };

  } // namespace DataRepresentation

} // namespace LibLSS
