/*+
    ARES/HADES/BORG Package -- libLSS/physics/data/mixer_representation_internal.hpp
    Copyright (C) 2021-2022 Guilhem Lavaux <guilhem.lavaux@iap.fr>

    Additional contributions from:
       Guilhem Lavaux <guilhem.lavaux@iap.fr> (2022)

+*/
#pragma once
#ifndef __LIBLSS_PHYSICS_DATA_MIXER_REPRESENTATION_INTERNAL_HPP
#  define __LIBLSS_PHYSICS_DATA_MIXER_REPRESENTATION_INTERNAL_HPP

#  include "libLSS/physics/data/data_representation.hpp"
#  include "libLSS/physics/data/mixer_representation.hpp"

namespace LibLSS {

  namespace DataRepresentation {

    struct OpaqueMixerDescriptor : OpaqueDescriptor {
      std::vector<Descriptor> descriptors;
      OpaqueMixerDescriptor(std::vector<Descriptor> const &descriptors_);
      std::shared_ptr<OpaqueDescriptor> clone() const override;
      AbstractRepresentation_p makeTemporaryForward() const override;
      AbstractRepresentation_p makeTemporaryAdjointGradient() const override;
    };

  } // namespace DataRepresentation

} // namespace LibLSS

#endif
// ARES TAG: authors_num = 1
// ARES TAG: name(0) = Guilhem Lavaux
// ARES TAG: year(0) = 2021-2022
// ARES TAG: email(0) = guilhem.lavaux@iap.fr
