/*+
    ARES/HADES/BORG Package -- ./libLSS/physics/forwards/pm/steps/types.hpp
    Copyright (C) 2014-2019 Guilhem Lavaux <guilhem.lavaux@iap.fr>
    Copyright (C) 2009-2018 Jens Jasche <jens.jasche@fysik.su.se>

    Additional contributions from:
       Guilhem Lavaux <guilhem.lavaux@iap.fr> (2018-2021)

+*/
#pragma once
#ifndef __LIBLSS_PM_ZOOM_STATE_HPP
#  define __LIBLSS_PM_ZOOM_STATE_HPP

#  include "libLSS/physics/forwards/pm/steps/types.hpp"

namespace LibLSS::PM {

  struct ZoomPMState : PMState {
    ConvGrid<true> zoom_force_resolution;
    ConvGrid<false> zoom_particles_resolution;
    ConvGrid<false> zoom_ic_resolution;
    ConvGrid<false> zoom_initial_particle_grid;

    //~ZoomPMState() { LIBLSS_AUTO_CONTEXT(LOG_DEBUG, ctx); }
  };

} // namespace LibLSS::PM

#endif
// ARES TAG: authors_num = 3
// ARES TAG: name(0) = Guilhem Lavaux
// ARES TAG: email(0) = guilhem.lavaux@iap.fr
// ARES TAG: year(0) = 2014-2019
// ARES TAG: name(1) = Jens Jasche
// ARES TAG: email(1) = jens.jasche@fysik.su.se
// ARES TAG: year(1) = 2009-2018
// ARES TAG: name(2) = Ewoud Wempe
// ARES TAG: email(2) = wempe@astro.rug.nl
// ARES TAG: year(2) = 2022
