/*+
+*/
#pragma once
#include "libLSS/physics/generic_cic.hpp"
#include "libLSS/physics/tiled_array.hpp"

namespace LibLSS {
  template <typename PeriodicFunction>
  constexpr TiledArray<double, 3>::PaddingType
  get_required_padding(bool bothsides) {
    using PaddingType = TiledArray<double, 3>::PaddingType;
    if (bothsides)
      return std::is_same_v<PeriodicFunction, CIC_Tools::NonPeriodic>
                 ? PaddingType{1, 1, 1, 1, 1, 1}
             : std::is_same_v<PeriodicFunction, CIC_Tools::Periodic_MPI>
                 ? PaddingType{1, 1, 0, 0, 0, 0}
                 : PaddingType{0, 0, 0, 0, 0, 0};
    else
      return std::is_same_v<PeriodicFunction, CIC_Tools::NonPeriodic>
                 ? PaddingType{0, 1, 0, 1, 0, 1}
             : std::is_same_v<PeriodicFunction, CIC_Tools::Periodic_MPI>
                 ? PaddingType{0, 1, 0, 0, 0, 0}
                 : PaddingType{0, 0, 0, 0, 0, 0};
  }

} // namespace LibLSS

// ARES TAG: num_authors = 1
// ARES TAG: name(0) = Ewoud Wempe
// ARES TAG: email(0) = wempe@astro.rug.nl
// ARES TAG: year(0) = 2022

