/*+
    ARES/HADES/BORG Package -- ./libLSS/samplers/ares/negative_foreground_sampler.hpp
    Copyright (C) 2014-2022 Guilhem Lavaux <guilhem.lavaux@iap.fr>
    Copyright (C) 2009-2022 Jens Jasche <jens.jasche@fysik.su.se>

    Additional contributions from:
       Guilhem Lavaux <guilhem.lavaux@iap.fr> (2016, 2018, 2020, 2022)
       elsner <f.elsner@mpa-garching.mpg.de> (2017)

+*/
#ifndef __LIBLSS_NEGATIVE_FOREGROUND_HPP
#define __LIBLSS_NEGATIVE_FOREGROUND_HPP

#include <boost/multi_array.hpp>
#include "libLSS/mpi/generic_mpi.hpp"
#include "libLSS/samplers/core/markov.hpp"
#include "libLSS/samplers/core/types_samplers.hpp"

namespace LibLSS {

  class NegativeForegroundSampler : public MarkovSampler {
  protected:
    int Ncat;
    long Ntot, localNtot;
    int catalog, fg_id;
    long N0, N1, N2, localN0, startN0;
    RandomGen *rng;
    MPI_Communication *comm;

  public:
    NegativeForegroundSampler(
        MPI_Communication *comm, int catalog, int foreground_id);

    virtual void initialize(MarkovState &state);
    virtual void restore(MarkovState &state);
    virtual void sample(MarkovState &state);
  };

}; // namespace LibLSS

#endif
