/*+
    ARES/HADES/BORG Package -- ./libLSS/samplers/borg/borg_oct_likelihood_marg.hpp
    Copyright (C) 2014-2022 Guilhem Lavaux <guilhem.lavaux@iap.fr>
    Copyright (C) 2009-2022 Jens Jasche <jens.jasche@fysik.su.se>

    Additional contributions from:
       Guilhem Lavaux <guilhem.lavaux@iap.fr> (2021)

+*/
#pragma once
#ifndef __LIBLSS_BORG_OCT_LIKELIHOOD_MARG_HPP
#  define __LIBLSS_BORG_OCT_LIKELIHOOD_MARG_HPP

#  include "libLSS/samplers/borg/borg_oct_likelihood.hpp"

namespace LibLSS {

  class BorgOctLikelihoodMarg : public BorgOctLikelihood {
  public:
    typedef BorgOctLikelihood super_t;

  protected:
    void computeAnalyticGradient(
        array_type_3 &ag, array_type_3 &sel_array, array_type_3 &biased_density,
        array_type_3 &g_field, unsigned int level) override;

    double computeAnalyticLikelihood(
        array_type_3 &g_field, array_type_3 &sel_array,
        array_type_3 &biased_density, unsigned int level) override;

  public:
    BorgOctLikelihoodMarg(LikelihoodInfo &info);
    virtual ~BorgOctLikelihoodMarg();
  };

}; // namespace LibLSS

LIBLSS_REGISTER_LIKELIHOOD_DECL(OCT_LIKELIHOOD_MARG);

#endif
