/*+
    ARES/HADES/BORG Package -- ./libLSS/samplers/generic/impl_skeleton.hpp
    Copyright (C) 2014-2022 Guilhem Lavaux <guilhem.lavaux@iap.fr>
    Copyright (C) 2009-2022 Jens Jasche <jens.jasche@fysik.su.se>

    Additional contributions from:
       Guilhem Lavaux <guilhem.lavaux@iap.fr> (2018-2021)

+*/
#include "libLSS/cconfig.h"
#include "generic_hmc_likelihood.hpp"

#include "generic_hmc_likelihood_impl.cpp"
#include "libLSS/physics/bias/noop.hpp"

#include "generic_meta_impl.cpp"
#include "generic_vobs_impl.cpp"
#include "generic_foreground_impl.cpp"
#include "generic_kharon.cpp"

#include <boost/preprocessor/tuple/elem.hpp>

#define LIKE_DECL(T)                                                           \
  LibLSS::GenericHMCLikelihood<                                                \
      BOOST_PP_TUPLE_ELEM(2, 0, T), BOOST_PP_TUPLE_ELEM(2, 1, T)>

#define META_DECL(z, n, T)                                                     \
  template class LibLSS::GenericMetaSampler<                                   \
      LIKE_DECL(T), LibLSS::BiasParamSelector<n>>;

#define FORCE_INSTANCE(BIAS, LIKELIHOOD, ...)                                  \
  template class LIKE_DECL((BIAS, LIKELIHOOD));                                \
  template class LibLSS::GenericCompleteMetaSampler<LIKE_DECL(                 \
      (BIAS, LIKELIHOOD))>;                                                    \
  template class LibLSS::GenericVobsSampler<LIKE_DECL((BIAS, LIKELIHOOD))>;    \
  template class LibLSS::GenericForegroundSampler<LIKE_DECL(                   \
      (BIAS, LIKELIHOOD))>;
