/*+
    ARES/HADES/BORG Package -- ./libLSS/samplers/rgen/density_sampler.hpp
    Copyright (C) 2019 Guilhem Lavaux <guilhem.lavaux@iap.fr>

    Additional contributions from:
       Florent Leclercq <florent.leclercq@polytechnique.org> (2021)
       Guilhem Lavaux <guilhem.lavaux@iap.fr> (2019-2021)

+*/
#pragma once
#ifndef __LIBLSS_SAMPLERS_DENSITY_SAMPLER_HPP
#  define __LIBLSS_SAMPLERS_DENSITY_SAMPLER_HPP

#  include <list>
#  include "libLSS/samplers/core/markov.hpp"
#  include "libLSS/samplers/core/main_loop.hpp"
#  include "libLSS/mcmc/global_state.hpp"
#  include "libLSS/tools/errors.hpp"

namespace LibLSS {

  class GenericDensitySampler : public MarkovSampler {
  public:
    virtual void generateMockDataMulti(std::list<StateTuple> states);
    virtual void generateMockData(MarkovState &state);
  };

} // namespace LibLSS

#endif
// ARES TAG: authors_num = 1
// ARES TAG: name(0) = Guilhem Lavaux
// ARES TAG: email(0) = guilhem.lavaux@iap.fr
// ARES TAG: year(0) = 2019
