HMCRealDensitySampler::HamiltonianType
HMCRealDensitySampler::computeHamiltonian_Prior(
    MarkovState &state, ArrayRef const &s_array) {
  auto s_w = fwrap(s_array);
  double Eprior = (s_w * s_w).sum();

  comm->all_reduce_t(MPI_IN_PLACE, &Eprior, 1, MPI_SUM);

  return Eprior * 0.5;
}

void HMCRealDensitySampler::computeGradientPsi_Prior(
    MarkovState &state, ArrayRef const &s_field, ArrayRef &grad_array) {
  ConsoleContext<LOG_DEBUG> ctx("gradient psi prior");
  if (exact_gaussian)
    fwrap(grad_array) = 0;
  else
    fwrap(grad_array) = fwrap(s_field);
}
