/*+
    ARES/HADES/BORG Package -- ./libLSS/tests/setup_hades_test_run.hpp
    Copyright (C) 2014-2022 Guilhem Lavaux <guilhem.lavaux@iap.fr>
    Copyright (C) 2009-2022 Jens Jasche <jens.jasche@fysik.su.se>

    Additional contributions from:
       Florent Leclercq <florent.leclercq@polytechnique.org> (2021)
       Guilhem Lavaux <guilhem.lavaux@iap.fr> (2017-2021)

+*/
#ifndef __LIBLSS_SETUP_HADES_TEST_HPP
#define __LIBLSS_SETUP_HADES_TEST_HPP

#include "libLSS/mpi/generic_mpi.hpp"
#include "libLSS/physics/forward_model.hpp"
#include "libLSS/mcmc/global_state.hpp"
#include "libLSS/physics/likelihoods/base.hpp"
#include <array>
#include <boost/optional/optional_fwd.hpp>

namespace LibLSS_test {
  void setup_box(LibLSS::MarkovState &state, LibLSS::BoxModel &box);
  void setup_hades_test_run(
      LibLSS::MPI_Communication *comm, size_t Nbase, double L[3],
      LibLSS::MarkovState &state,
      boost::multi_array_ref<double, 1> *bias_params = 0,
      boost::optional<std::array<double, 3>> special_corner =
          boost::optional<std::array<double, 3>>());

  void setup_hades_test_run(
      LibLSS::MPI_Communication *comm, size_t Nbase, double L,
      LibLSS::MarkovState &state,
      boost::multi_array_ref<double, 1> *bias_params = 0,
      boost::optional<std::array<double, 3>> special_corner =
          boost::optional<std::array<double, 3>>());

  void setup_likelihood_info(
      LibLSS::MarkovState &state, LibLSS::LikelihoodInfo &info,
      LibLSS::MPI_Communication *comm = LibLSS::MPI_Communication::instance());
} // namespace LibLSS_test

#endif
