/*+
+*/
#pragma once
#ifndef __LIBLSS_TOOLS_CONSOLE_TOOLS_HPP
#  define __LIBLSS_TOOLS_CONSOLE_TOOLS_HPP

#  include "libLSS/tools/console.hpp"

namespace LibLSS {

  struct TemporaryLogLevel {
    int oldLevel;
    bool valueSet;

    TemporaryLogLevel(TemporaryLogLevel &&l) {
      oldLevel = l.oldLevel;
      l.valueSet = false;
    }

    TemporaryLogLevel(int level) {
      valueSet = true;
      oldLevel = Console::instance().getVerboseLevel();
      Console::instance().setVerboseLevel(level);
    }

    ~TemporaryLogLevel() {
      if (valueSet)
        Console::instance().setVerboseLevel(oldLevel);
    }

    template <typename LogLevel>
    static TemporaryLogLevel set() {
      return TemporaryLogLevel(LogLevel::verboseLevel);
    }
  };

} // namespace LibLSS

#endif
// ARES TAG: num_authors = 1
// ARES TAG: name(0) = Guilhem Lavaux
// ARES TAG: email(0) = guilhem.lavaux@iap.fr
// ARES TAG: year(0) = 2022
