#pragma once
#ifndef __LIBLSS_TOOLS_MEMBER_CHECK_HPP
#  define __LIBLSS_TOOLS_MEMBER_CHECK_HPP

// https://stackoverflow.com/questions/1966362/sfinae-to-check-for-inherited-member-functions/8752988
#  define MEMBER_FUNC_CHECKER(name, fn, args)                                  \
    template <class C, typename ret, typename = void>                          \
    struct name : std::false_type {};                                          \
    template <class C, typename ret>                                           \
    struct name<                                                               \
        C, ret,                                                                \
        typename std::enable_if<std::is_convertible<                           \
            decltype(std::declval<C>().fn args), ret>::value>::type>           \
        : std::true_type {};

#  define MEMBER_VAR_CHECKER(name, var)                                        \
    template <class C, typename ret, typename = void>                          \
    struct name : std::false_type {};                                          \
    template <class C, typename ret>                                           \
    struct name<                                                               \
        C, ret,                                                                \
        typename std::enable_if<                                               \
            std::is_convertible<decltype(C::var), ret>::value>::type>          \
        : std::true_type {};

#endif
