/*+
    ARES/HADES/BORG Package -- libLSS/tools/ref_registry.hpp
    Copyright (C) 2023 Guilhem Lavaux <guilhem.lavaux@iap.fr>

    Additional contributions from:
       Guilhem Lavaux <guilhem.lavaux@iap.fr> (2023)

+*/
#pragma once
#ifndef __LIBLSS_TOOLS_REF_REGISTRY_HPP
#  define __LIBLSS_TOOLS_REF_REGISTRY_HPP

#  include <list>
#  include <string>

namespace LibLSS {

  struct CitationData {
    std::string arxiv_ref;
    std::string text_citation;
  };

  class ReferenceRegistry {
  private:
    std::list<CitationData> citations;

    ReferenceRegistry() = default;

  public:
    ReferenceRegistry &instance();

    void reportCitations();

    void registerReference(CitationData const &data);
  };

} // namespace LibLSS

#  define LIBLSS_CITE(arxiv, citation)                                         \
    LibLSS::ReferenceRegistry::instance().registerReference({arxiv, citation});

#endif
// ARES TAG: num_authors = 1
// ARES TAG: name(0) = Guilhem Lavaux
// ARES TAG: year(0) = 2023
// ARES TAG: email(0) = guilhem.lavaux@iap.fr
