/*+
    ARES/HADES/BORG Package -- ./libLSS/tools/timing_db.hpp
    Copyright (C) 2014-2022 Guilhem Lavaux <guilhem.lavaux@iap.fr>
    Copyright (C) 2009-2022 Jens Jasche <jens.jasche@fysik.su.se>

    Additional contributions from:
       Florent Leclercq <florent.leclercq@polytechnique.org> (2021)
       Guilhem Lavaux <guilhem.lavaux@iap.fr> (2019-2020)

+*/
#ifndef __LIBLSS_TOOLS_TIMING_DB_HPP
#define __LIBLSS_TOOLS_TIMING_DB_HPP

#include <CosmoTool/hdf5_array.hpp>
#include "libLSS/tools/hdf5_type.hpp"
#include <map>

namespace LibLSS {

  namespace timings {

    struct StatInfo {
      size_t count;
      double total_time;

      StatInfo() : count(0), total_time(0) {}
    };

    std::map<std::string, StatInfo> timingReport();
    void clearTimingReport();

    void load(H5_CommonFileGroup &g);
    void save(H5_CommonFileGroup &g);
  } // namespace timings

} // namespace LibLSS

#endif
