IFS=' ' read -ra SPLIT_CC <<< "$CC"
IFS=' ' read -ra SPLIT_CXX <<< "$CXX"
CC=${SPLIT_CC[0]}
CXX=${SPLIT_CXX[0]}

echo "Building  Conda version ${BORG_CONDA_VERSION}"

export CC=$(which $(basename ${CC}) )
export CXX=$(which $(basename ${CXX}) )

#$PYTHON setup.py install

additional_arg="--deprecated"
echo "BORG_MPI is $BORG_MPI"

if [[ x$BORG_MPI != xnompi ]]; then
  additional_arg="$additional_arg --with-mpi"
else
  additional_arg="$additional_arg --use-system-fftw"
fi

if [[ x$BORG_PREDOWNLOAD != x ]]; then
  if [[ -d $BORG_PREDOWNLOAD ]]; then
     rm -fr downloads/
     rsync -r $BORG_PREDOWNLOAD/ downloads/
     rm -f downloads/deps.txt
  fi
  additional_arg="$additional_arg --use-predownload"
  bash build.sh --download-deps
  rsync -r downloads/ $BORG_PREDOWNLOAD/
fi

if [ $(uname) = Darwin ]; then
  JOBS=2
  additional_arg="$additional_arg --without-openmp"
else
  JOBS=4
fi

bash build.sh --c-compiler ${CC} --cxx-compiler ${CXX} \
     --extra-flags "-DCMAKE_INSTALL_PREFIX=${PREFIX} -DCMAKE_BUILD_TYPE=RelWithDebInfo" \
     --build-dir $(pwd)/build/ \
     --install-dir $PREFIX \
     --python=${PYTHON} --hades-python --install-system-python \
     --use-system-boost --use-system-gsl --use-system-hdf5 \
     --use-system-xtensor --use-system-tbb --use-system-eigen --use-system-cfitsio \
     --purge ${additional_arg}


(cd build/; make -j$JOBS python-install tools-install liblss-install)
