try:
    import astropy.cosmology as aco
    from .. import cosmo
    import numpy as np

    def _convert_cosmology(
        astropy_cosmo: aco.Cosmology, borg_cosmo: cosmo.CosmologicalParameters
    ):
        cosmo = astropy_cosmo.to_format("mapping")
        borg_cosmo.h = cosmo["H0"].value / 100
        borg_cosmo.omega_m = cosmo["Om0"]
        borg_cosmo.sum_mnu = np.array(cosmo["m_nu"].value).sum()
        borg_cosmo.omega_b = cosmo["Ob0"]
        borg_cosmo.omega_k = 0
        borg_cosmo.omega_q = 1 - borg_cosmo.omega_k - borg_cosmo.omega_m
        borg_cosmo.w = -1
        borg_cosmo.wprime = 0
        borg_cosmo.sigma8 = cosmo["meta"]["sigma8"]
        borg_cosmo.A_s = 0

except ImportError as e:
    _astropy_exception = e

    def _convert_cosmology(astropy_cosmo, borg_cosmo):
        global _astropy_exception
        raise _astropy_exception


__all__ = ["_convert_cosmology"]
