"""
Utility functions
-----------------

General utility functions for borg data management.

"""

import numpy as np
from .borg_native import *


def newComplexOutputSlab(fwd_model: forward.BORGForwardModel):
    """Helper function to create an empty numpy of the correct shape for the given forward model

    Args:
      * fwd_model: A BORGForwardModel

    Returns:
       numpy.ndarray: An allocated numpy array with MPI slicing
    """
    startN0, localN0, N1, N2 = fwd_model.getMPISlice()
    return np.empty((localN0, N1, N2 // 2 + 1), dtype=np.complex128)


def newRealOutputSlab(fwd_model: forward.BORGForwardModel):
    """Helper function to create an empty numpy of the correct shape for the given forward model

    Args:
      * fwd_model: A BORGForwardModel

    Returns:
       numpy.ndarray: An allocated numpy array with MPI slicing
    """
    startN0, localN0, N1, N2 = fwd_model.getMPISlice()
    return np.empty((localN0, N1, N2))
