/*
 *  This file is part of libcxxsupport.
 *
 *  libcxxsupport is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  libcxxsupport is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with libcxxsupport; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

/*
 *  libcxxsupport is being developed at the Max-Planck-Institut fuer Astrophysik
 *  and financially supported by the Deutsches Zentrum fuer Luft- und Raumfahrt
 *  (DLR).
 */

/*! \file xcomplex.h
 *  convenience additions for std::complex
 *
 *  Copyright (C) 2003-2015 Max-Planck-Society
 *  \author Martin Reinecke
 */

#ifndef PLANCK_XCOMPLEX_H
#define PLANCK_XCOMPLEX_H

#include <complex>

// This is a really bad hack as it creates namespace collision with xtensor (while leaving in the global namespace)
// Remove it and use hpx_complex as a type
// #define xcomplex std::complex
template<typename T> using hpx_complex = std::complex<T>;
typedef hpx_complex<float>  fcomplex;
typedef hpx_complex<double> dcomplex;

template<typename T> inline hpx_complex<T> times_i(hpx_complex<T> inp)
  { return hpx_complex<T>(-inp.imag(),inp.real()); }

#endif
